#define	StackSize 1048576


#ifndef _Device_
#define _Device_

//extern bool InitLib;
//extern bool NeedDeinitCOM;
//extern HINSTANCE g_hinst;
//extern init Init;
//void SendLogMessage( char* t, char* mess);

const GUID CLSID_OPCServerList = {0x13486D51,0x4821,0x11D2,{0xA4,0x94,0x3C,0xB3,0x06,0xC1,0x00,0x00}};
const GUID CATID_OPCDAServer20 = {0x63d5f432,0xcfe4,0x11d1,{0xb2,0xc8,0x00,0x60,0x08,0x3b,0xa1,0xfb}};

//extern const GUID CLSID_OPCServerList;
//extern const GUID CATID_OPCDAServer20;
extern const GUID CATID_OPCDAServer10;



#define TESTINIT 	if(!InitLib || !NeedDeinitCOM)return


typedef enum {
	TC_Device,
	TC_Group,
	TC_TAG
}TypeClass;

class Group;
class Tag;

class P
{
  public:
	ULONG TestTag;

	TypeClass TC;
	P *Parent;
	BOOL TestAddres;

	P(TypeClass t, P*p)
	{
		TC=t; Parent=p;
		if(Parent && (Parent->TC==TC_Device || Parent->TC==TC_Group || Parent->TC==TC_TAG))
		TestAddres = Parent->TestAddres;
	}
	~P(){};
};

class COPCReceiveData;
class COPCDataCallback;

class Device :	public P,
		public IOPCShutdown
{
	DWORD mRefCount;
  public:
	HANDLE hgetstetus;
	HANDLE hconcect;

	ULONG Users;

	DWORD m_Cookie;

	IConnectionPoint *m_ConnectionPoint;

	char * NameMash;
	char * NameServ;
	COSERVERINFO ServerInfo;
	OPCSERVERSTATUS *OPCStatus;

	IOPCServer			*OPCServer;
	IOPCServerPublicGroups		*OpcPublicGroups;
	IOPCBrowseServerAddressSpace 	*OpcBrowseServerAddressSpace;
	IOPCItemProperties 		*OpcItemProperties;
	IConnectionPointContainer 	*ConnectionPointContainer;
	IOPCCommon 			*OPCCommon;
	IPersistFile 			*PersistFile;

	//std::vector<Group*>GroupList;

	BOOL ConnectServer;

	Device(char*,char*, ULONG u);
	~Device();


	BOOL connectOPC();

	ULONG GetDeviceInfo(srvname*inf);

	ULONG AddGroup(char *gn, BOOL active, ULONG reqUpdateRate_ms, ULONG Users);
	ULONG DeleteGroup(Group* g);
	ULONG GetConnection(ULONG Users);

	void Reconnect( LPCWSTR szReason);

	STDMETHODIMP QueryInterface( REFIID iid, LPVOID* ppInterface);
	STDMETHODIMP_(ULONG) AddRef(){return ++mRefCount;}
	STDMETHODIMP_(ULONG) Release(){return --mRefCount;}
	STDMETHODIMP ShutdownRequest( LPCWSTR szReason);


};


class Group :	public P,
		public IOPCDataCallback
{
 	DWORD mRefCount;
 public:
	ULONG User;
	ULONG Users;

	BOOL Active;
	ULONG UpdateRate;

	char *NameGroup;
	DWORD groupHandle;
	unsigned long revisedUpdateRate_ms;

	DWORD m_Cookie;
	IConnectionPoint *m_ConnectionPoint;

	IOPCGroupStateMgt *OPCGroupStateMgt;

	IOPCSyncIO	*OPCSyncIO;
	IOPCAsyncIO2	*OPCASyncIO2;
	IOPCItemMgt	*OPCItemMgt;
	IConnectionPointContainer* ConnectionPointContainer2;


//	std::vector<Tag*>TagList;

	Group(char*s, BOOL active, ULONG reqUpdateRate_ms, Device *p, ULONG u);
	~Group();
	inline Device * GetParent() {return (Device *)Parent;};

	void Shutdown();

	void NewGroup();
	void InitGroup();

	ULONG Start();
	ULONG AddTag(char*nt, ULONG Users);
	ULONG NewTag(HWND hWnd, ULONG users);
	ULONG DeleteTag(Tag *Tag);


	// IOPCDataCallback
	STDMETHODIMP QueryInterface( REFIID iid, LPVOID* ppInterface);
	STDMETHODIMP_(ULONG) Group::AddRef(){return ++mRefCount;}
	STDMETHODIMP_(ULONG) Group::Release(){return --mRefCount;}
	STDMETHODIMP OnDataChange(DWORD Transid, OPCHANDLE grphandle, HRESULT masterquality, HRESULT mastererror, DWORD count, OPCHANDLE * clienthandles, VARIANT * values, WORD * quality, FILETIME  * time, HRESULT * errors);
	STDMETHODIMP OnReadComplete(DWORD Transid, OPCHANDLE grphandle, HRESULT masterquality, HRESULT mastererror, DWORD count, OPCHANDLE * clienthandles, VARIANT* values, WORD * quality, FILETIME * time, HRESULT * errors){return S_OK;}
	STDMETHODIMP OnWriteComplete(DWORD Transid, OPCHANDLE grphandle, HRESULT mastererr, DWORD count, OPCHANDLE * clienthandles, HRESULT * errors){return S_OK;}
	STDMETHODIMP OnCancelComplete(DWORD transid, OPCHANDLE grphandle){return S_OK;}
};



class Tag : public P
{
  public:
	BOOL InitOk;
	val *Val;
	char *NameTag;
	int hClient;
	OPCHANDLE hServer;
	ULONG Users;
	Tag(char*s, Group *p, ULONG Users);
	~Tag();
	inline Group * GetParent() {return (Group *)Parent;};

	void InitTag();
	ULONG GetAddrTag();
};

#endif
